/*
 * Это пример использования библиотеки Spirit 
 * для получения объемного процентного содержания спирта 
 * в кипящей жидкости и пару над ней
 * Таблица расчета получена с помощью Калькулятора Руди.
 * Автор; GremLine (03.2017) 
 */
 
#include <spirit.h>

void setup() {
  // Будем использовать последовательный порт для ввода/вывода
  Serial.begin(9600);

}

void loop() {
  // Пример калькулятора спирта
 unsigned char TeL, TeH;
 unsigned int Tem, Td;
 unsigned int PrcLk,PrcSt;

 /* Вводим значение температуры с помощью терминала */
 Serial.println("Input Temperature in degree, format: XX,X ");
 while (Serial.available() == 0);
 Tem = Serial.parseInt();
 Td = 0;
 if (Serial.read()==',') {
  Td = Serial.parseInt(); 
 }
 if (Td > 9) {
  Serial.println("ERROR: Only 1 digit after coma!"); 
  return;
 }
 
 /* Теперь переведем температуру из градусов в формат датчика DS18B20 */
 TeH = (Tem >> 4) & 0xFF;
 TeL = ((Tem << 4) & 0xF0) + (Td * 16) / 10;

 /* Вызываем функцию расчета из библиотеки */
 Spirit.Calc(TeL, TeH);
 
 /* Получаем результаты расчета */
 PrcLk = Spirit.GetPrcLk(); // Процент спирта в жидкости (в десятых процента)
 PrcSt = Spirit.GetPrcSt(); // Процент спирта в пару (в десятых процента)
 Tem = Spirit.GetTemp();    // Измеренная температура (в десятых градуса)

 /* Распечатываем результат */
 Serial.print("Temperature: ");
 Serial.print(Tem/10); Serial.print(",");Serial.println(Tem%10);
 Serial.print("Percent in liquid: ");
 Serial.print(PrcLk/10); Serial.print(",");Serial.println(PrcLk%10);
 Serial.print("Percent in steam: ");
 Serial.print(PrcSt/10); Serial.print(",");Serial.println(PrcSt%10);
 
}

