#include "Arduino.h"
#include "spirit.h"
/*
 *                  ()
 *	    . 
 *	         DS18B20,   
 *	   .
 *         -   .
 *	      
 *
 *	 :  ,     DS18B20
 *      : 
 *	-   -      
 *	-  -       
 *
 *     : GremLine (03.2017) 
 *	sv-sokolov@yandex.ru
 */

#define PGM  PROGMEM

//   
static const unsigned int TempTabC[45] PGM = {
 0, 38, 101, 155, 212, 272, 334, 400, 473, 546, 619, 697, 775, 852, 932, 1016,
 1103, 1204, 1318, 1488, 1565, 1659, 1853, 1940, 2064, 2295, 2454, 2653, 2905,
 3125, 3395, 3740, 4031, 4407, 4812, 5167, 5687, 6190, 6774, 7334, 7870, 8549,
 8923, 9327, 9717};
 
//   
static const unsigned int TempTabP[45] PGM = {
 0, 477, 1121, 1584, 2076, 2552, 2995, 3427, 3837, 4146, 4377, 4665, 4929, 5161,
 5376, 5579, 5754, 5937, 6125, 6368, 6466, 6578, 6774, 6848, 6956, 7144, 7243, 
 7365, 7503, 7612, 7722, 7845, 7935, 8028, 8108, 8182, 8284, 8384, 8508, 8631,
 8776, 9011, 9185, 9421, 9717};
 
//  
static unsigned int PrcLk, PrcSt; 
static unsigned int TempDg;

//  
static int CalcPrc(unsigned char TempL, unsigned char TempH) 
{
  unsigned int Tab1, Tab2;
  int T, N;
  TempDg = (TempH << 4) | (TempL >> 4);
  TempDg *= 10;
  T = ((TempL & 0x0F) * 10+8) / 16;
  TempDg += T;
  T = (TempH<<5)|(TempL>>3);
  if (((TempH == 4) && (TempL<0xE3)) || (TempH < 4))
  {
   PrcLk = PrcSt = 972;
   return -1;
  }  
  if (T>=200)
  {
   PrcLk = PrcSt = 0;
   return -1;
  }  
  N = 200 - T;

  Tab1 = pgm_read_word(&TempTabP[N-1]);
  Tab2 = pgm_read_word(&TempTabP[N]);
  PrcSt =  ((Tab2 - Tab1) * (TempL & 7)) >> 3;
  PrcSt = Tab2 - PrcSt;
  PrcSt = (PrcSt+5)/10;
  Tab1 = pgm_read_word(&TempTabC[N-1]);
  Tab2 = pgm_read_word(&TempTabC[N]);
  PrcLk =  ((Tab2 - Tab1) * (TempL & 7)) >> 3;
  PrcLk = Tab2 - PrcLk;
  PrcLk = (PrcLk+5)/10;
  return 0;
}  

//   
static unsigned int getLk() { return PrcLk; }
static unsigned int getSt() { return PrcSt; }
static unsigned int getT()  { return TempDg;}

//  
struct spirit_t Spirit = 
                  {
                   .Calc = CalcPrc,
                   .GetPrcLk = getLk,
                   .GetPrcSt = getSt,
                   .GetTemp = getT
                  }; 